image: "python:3.7"
stages:
  - lint
  - build
  - deploy
variables:
  GIT_SUBMODULE_STRATEGY: recursive
run-pre-commit:
  image: python:3.7
  stage: lint
  script:
    - pip install pre-commit
    - pre-commit install
    - pre-commit run --all-files --show-diff-on-failure
build:
  stage: build
  script:
    - pip install poetry
    - poetry config experimental.new-installer false
    - poetry config virtualenvs.create false
    - poetry install
    - make html
  artifacts:
    paths:
      - _build
    untracked: false
    expire_in: 30 days
deploy:
  stage: deploy
  only:
    - master
  script:
    - pip install poetry
    - poetry config experimental.new-installer false
    - poetry config virtualenvs.create false
    - poetry install
    - aws s3 cp ./_build/html s3://developer.nomnomdata.com/ --recursive
    - aws cloudfront create-invalidation --distribution-id E1AC246VVJ8TSP --paths "/*"
